/*
 * Copyright (c) 2012, The Linux Foundation. All rights reserved.
 *
 * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
 *
 *
 * Permission to use, copy, modify, and/or distribute this software for
 * any purpose with or without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
 * AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

/*===========================================================================
 *
 *  @file:     wlan_defs.h
 *
 *  @brief:       This file defines the common typedefs
 *
 *  @author:   Gagan Jain
 *
 *             Copyright (C) 2010, Qualcomm, Inc. 
 *             All rights reserved.
 *
 *=========================================================================*/

#ifndef __WLAN_DEFS_H__
#define __WLAN_DEFS_H__

/*-------------------------------------------------------------------------
  Include Files
-------------------------------------------------------------------------*/
#include "wlan_qct_pal_type.h" 

/*----------------------------------------------------------------------------
 * Preprocessor Definitions and Constants
 * -------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------
 *  Type Declarations
 * -------------------------------------------------------------------------*/
typedef wpt_uint32   uint32;      /* Unsigned 32 bit value */

typedef wpt_uint16   uint16;      /* Unsigned 16 bit value */

typedef wpt_uint8    uint8;       /* Unsigned 8  bit value */

typedef wpt_int32    int32;       /* Signed 32 bit value */

typedef wpt_int16    int16;       /* Signed 16 bit value */

typedef wpt_int8     int8;        /* Signed 8  bit value */

typedef wpt_int64    int64;       /* Signed 64 bit value */

typedef wpt_uint64   uint64;      /* Unsigned 64 bit value */

typedef wpt_byte     byte;        /* byte type */

typedef wpt_boolean  boolean;     /* Boolean Type */

#endif //__WLAN_DEFS_H__
