/*
 *
 * This file is provided under a dual BSD/GPLv2 license.  When using or
 * redistributing this file, you may do so under either license.
 *
 * GPL LICENSE SUMMARY
 *
 * Copyright(c) 2010-2011 Texas Instruments Incorporated,
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
 * The full GNU General Public License is included in this distribution
 * in the file called LICENSE.GPL.
 *
 * BSD LICENSE
 *
 * Copyright(c) 2010-2011 Texas Instruments Incorporated,
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *   distribution.
 * * Neither the name of Texas Instruments Incorporated nor the names of
 *   its contributors may be used to endorse or promote products derived
 *   from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
#ifndef _ABE_TASKID_H_
#define _ABE_TASKID_H_
#define C_ABE_FW_TASK_ASRC_VX_DL_8                          0
#define C_ABE_FW_TASK_ASRC_VX_DL_16                         1
#define C_ABE_FW_TASK_ASRC_VX_DL_8_SIB                      2
#define C_ABE_FW_TASK_ASRC_VX_DL_16_SIB                     3
#define C_ABE_FW_TASK_ASRC_MM_EXT_IN                        4
#define C_ABE_FW_TASK_ASRC_VX_UL_8                          5
#define C_ABE_FW_TASK_ASRC_VX_UL_16                         6
#define C_ABE_FW_TASK_ASRC_VX_UL_8_SIB                      7
#define C_ABE_FW_TASK_ASRC_VX_UL_16_SIB                     8
#define C_ABE_FW_TASK_VX_UL_48_8_DEC                        9
#define C_ABE_FW_TASK_VX_UL_48_16_DEC                       10
#define C_ABE_FW_TASK_BT_DL_48_8_DEC                        11
#define C_ABE_FW_TASK_BT_DL_48_16_DEC                       12
#define C_ABE_FW_TASK_ECHO_REF_48_8_DEC                     13
#define C_ABE_FW_TASK_ECHO_REF_48_16_DEC                    14
#define C_ABE_FW_TASK_DL2_EQ                                15
#define C_ABE_FW_TASK_ECHO_REF_48_16                        16
#define C_ABE_FW_TASK_ECHO_REF_48_8                         17
#define C_ABE_FW_TASK_GAIN_UPDATE                           18
#define C_ABE_FW_TASK_SideTone                              19
#define C_ABE_FW_TASK_VX_DL_8_48_LP                         20
#define C_ABE_FW_TASK_VX_DL_8_48_HP                         21
#define C_ABE_FW_TASK_VX_DL_16_48_LP                        22
#define C_ABE_FW_TASK_VX_DL_16_48_HP                        23
#define C_ABE_FW_TASK_VX_UL_48_8_LP                         24
#define C_ABE_FW_TASK_VX_UL_48_8_HP                         25
#define C_ABE_FW_TASK_VX_UL_48_16_LP                        26
#define C_ABE_FW_TASK_VX_UL_48_16_HP                        27
#define C_ABE_FW_TASK_BT_UL_8_48_LP                         28
#define C_ABE_FW_TASK_BT_UL_8_48_HP                         29
#define C_ABE_FW_TASK_BT_UL_16_48_LP                        30
#define C_ABE_FW_TASK_BT_UL_16_48_HP                        31
#define C_ABE_FW_TASK_BT_DL_48_8_LP                         32
#define C_ABE_FW_TASK_BT_DL_48_8_HP                         33
#define C_ABE_FW_TASK_BT_DL_48_16_LP                        34
#define C_ABE_FW_TASK_BT_DL_48_16_HP                        35
#define C_ABE_FW_TASK_ECHO_REF_48_8_LP                      36
#define C_ABE_FW_TASK_ECHO_REF_48_8_HP                      37
#define C_ABE_FW_TASK_ECHO_REF_48_16_LP                     38
#define C_ABE_FW_TASK_ECHO_REF_48_16_HP                     39
#define C_ABE_FW_TASK_DL1_EQ                                40
#define C_ABE_FW_TASK_IHF_48_96_LP                          41
#define C_ABE_FW_TASK_EARP_48_96_LP                         42
#define C_ABE_FW_TASK_DL1_GAIN                              43
#define C_ABE_FW_TASK_DL2_GAIN                              44
#define C_ABE_FW_TASK_IO_PING_PONG                          45
#define C_ABE_FW_TASK_IO_DMIC                               46
#define C_ABE_FW_TASK_IO_PDM_UL                             47
#define C_ABE_FW_TASK_IO_BT_VX_UL                           48
#define C_ABE_FW_TASK_IO_MM_UL                              49
#define C_ABE_FW_TASK_IO_MM_UL2                             50
#define C_ABE_FW_TASK_IO_VX_UL                              51
#define C_ABE_FW_TASK_IO_MM_DL                              52
#define C_ABE_FW_TASK_IO_VX_DL                              53
#define C_ABE_FW_TASK_IO_TONES_DL                           54
#define C_ABE_FW_TASK_IO_VIB_DL                             55
#define C_ABE_FW_TASK_IO_BT_VX_DL                           56
#define C_ABE_FW_TASK_IO_PDM_DL                             57
#define C_ABE_FW_TASK_IO_MM_EXT_OUT                         58
#define C_ABE_FW_TASK_IO_MM_EXT_IN                          59
#define C_ABE_FW_TASK_DEBUG_IRQFIFO                         60
#define C_ABE_FW_TASK_EchoMixer                             61
#define C_ABE_FW_TASK_SDTMixer                              62
#define C_ABE_FW_TASK_DL1Mixer                              63
#define C_ABE_FW_TASK_DL2Mixer                              64
#define C_ABE_FW_TASK_DL1Mixer_dual_mono                    65
#define C_ABE_FW_TASK_DL2Mixer_dual_mono                    66
#define C_ABE_FW_TASK_VXRECMixer                            67
#define C_ABE_FW_TASK_ULMixer                               68
#define C_ABE_FW_TASK_ULMixer_dual_mono                     69
#define C_ABE_FW_TASK_VIBRA_PACK                            70
#define C_ABE_FW_TASK_VX_DL_8_48_0SR                        71
#define C_ABE_FW_TASK_VX_DL_16_48_0SR                       72
#define C_ABE_FW_TASK_BT_UL_8_48_0SR                        73
#define C_ABE_FW_TASK_BT_UL_16_48_0SR                       74
#define C_ABE_FW_TASK_IHF_48_96_0SR                         75
#define C_ABE_FW_TASK_EARP_48_96_0SR                        76
#define C_ABE_FW_TASK_AMIC_SPLIT                            77
#define C_ABE_FW_TASK_DMIC1_SPLIT                           78
#define C_ABE_FW_TASK_DMIC2_SPLIT                           79
#define C_ABE_FW_TASK_DMIC3_SPLIT                           80
#define C_ABE_FW_TASK_VXREC_SPLIT                           81
#define C_ABE_FW_TASK_BT_UL_SPLIT                           82
#define C_ABE_FW_TASK_MM_SPLIT                              83
#define C_ABE_FW_TASK_VIBRA_SPLIT                           84
#define C_ABE_FW_TASK_MM_EXT_IN_SPLIT                       85
#define C_ABE_FW_TASK_ECHO_REF_SPLIT                        86
#define C_ABE_FW_TASK_UNUSED_1                              87
#define C_ABE_FW_TASK_VX_UL_ROUTING                         88
#define C_ABE_FW_TASK_MM_UL2_ROUTING                        89
#define C_ABE_FW_TASK_VIBRA1                                90
#define C_ABE_FW_TASK_VIBRA2                                91
#define C_ABE_FW_TASK_BT_UL_16_48                           92
#define C_ABE_FW_TASK_BT_UL_8_48                            93
#define C_ABE_FW_TASK_BT_DL_48_16                           94
#define C_ABE_FW_TASK_BT_DL_48_8                            95
#define C_ABE_FW_TASK_VX_DL_16_48                           96
#define C_ABE_FW_TASK_VX_DL_8_48                            97
#define C_ABE_FW_TASK_VX_UL_48_16                           98
#define C_ABE_FW_TASK_VX_UL_48_8                            99
#define C_ABE_FW_TASK_DBG_SYNC                              100
#define C_ABE_FW_TASK_AMIC_96_48_LP                         101
#define C_ABE_FW_TASK_DMIC1_96_48_LP                        102
#define C_ABE_FW_TASK_DMIC2_96_48_LP                        103
#define C_ABE_FW_TASK_DMIC3_96_48_LP                        104
#define C_ABE_FW_TASK_INIT_FW_MEMORY                        105
#define C_ABE_FW_TASK_DEBUGTRACE_VX_ASRCs                   106
#define C_ABE_FW_TASK_ASRC_BT_UL_8                          107
#define C_ABE_FW_TASK_ASRC_BT_UL_16                         108
#define C_ABE_FW_TASK_ASRC_BT_UL_8_SIB                      109
#define C_ABE_FW_TASK_ASRC_BT_UL_16_SIB                     110
#define C_ABE_FW_TASK_ASRC_BT_DL_8                          111
#define C_ABE_FW_TASK_ASRC_BT_DL_16                         112
#define C_ABE_FW_TASK_ASRC_BT_DL_8_SIB                      113
#define C_ABE_FW_TASK_ASRC_BT_DL_16_SIB                     114
#define C_ABE_FW_TASK_BT_DL_48_8_HP_OPP100                  115
#define C_ABE_FW_TASK_BT_DL_48_16_HP_OPP100                 116
#define C_ABE_FW_TASK_BT_DL_48_8_OPP100                     117
#define C_ABE_FW_TASK_BT_DL_48_16_OPP100                    118
#define C_ABE_FW_TASK_VX_DL_8_48_OSR_LP                     119
#define C_ABE_FW_TASK_VX_DL_8_48_FIR                        120
#define C_ABE_FW_TASK_BT_UL_8_48_OSR_LP                     121
#define C_ABE_FW_TASK_BT_UL_8_48_FIR                        122
#define C_ABE_FW_TASK_SRC44P1_MMDL                          123
#define C_ABE_FW_TASK_SRC44P1_TONES                         124
#define C_ABE_FW_TASK_SRC44P1_MMDL_1211                     125
#define C_ABE_FW_TASK_SRC44P1_TONES_1211                    126
#endif /* _ABE_TASKID_H_ */
